package cz.moneta.test.regression.backoffice.ufooperations.jenkinstests;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.util.credentials.Keys;
import cz.moneta.test.dsl.util.task.ufo.operations.OperationsTasks;
import cz.moneta.test.harness.annotations.Environment;
import cz.moneta.test.harness.annotations.JiraTestCase;
import cz.moneta.test.harness.annotations.TestCase;
import cz.moneta.test.harness.annotations.TestScenario;
import cz.moneta.test.harness.support.auth.Credentials;
import cz.moneta.test.harness.support.auth.Key;
import org.junit.jupiter.api.AfterEach;

import static cz.moneta.test.dsl.util.task.ufo.cb.CommercialTasks.JIRA_COMMENT_STORE_KEY;

@TestScenario(name = "Administration")
public class Administration {

    @TestCase(name = "Administration", environments = {Environment.PPE, Environment.TST1})
    @JiraTestCase(id = "BOC-T8464")
    public void administration(Harness harness, @Key(Keys.ufo.banka.banker) Credentials credentials) {

        OperationsTasks operationsTasksTasks = harness.tasks().ufo().operations();

        harness.withUfo()
                .openLoginPage()
                .then(operationsTasksTasks.login().withCredentials(credentials))
                .clickTasks()
                .clickAdministration()
                .clickAllGroups()
                .clickDetailGroups()
                .clickUserAgata()
                .fillSso("212429126")
                .clickSearchSso()
                .checkGroupsIncludedTableNotEmpty()
                .checkGroupsManagerTableNotEmpty();
    }

    @AfterEach
    protected void teardown(Harness harness) {
        harness.store(JIRA_COMMENT_STORE_KEY,
                "\nUFO Session ID: " + harness.get("reports.tmfj.execution.commentufosessionid"));
    }

}